#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef complex<ll> pt;
typedef vector<pt> vpt;
typedef pair<int, int> ii;

#define px real()
#define py imag()
#define xx first
#define yy second

int sgn (ll v) { return (v > 0) - (v < 0); }
// -1 (cw), 0 (colinear), +1 (ccw)
int seg_ornt (pt a, pt b, pt c) {
  return sgn((conj(b - a) * (c - a)).py);
}

vpt convex_hull /* O(n lg n) */ (vpt& ps) {
  int k = 0, n = ps.size();
  vpt result (n * 2);

  sort(ps.begin(), ps.end(), [](pt a, pt b) {
    return make_pair(a.px, a.py) < make_pair(b.px, b.py);
  });

  for (int i = 0; i < n; i++) {
    while (k >= 2 && seg_ornt( /* lower hull */
        result[k-2], result[k-1], ps[i]) <= 0) k--;
    result[k++] = ps[i];
  }

  for (int i = n - 2, t = k + 1; i >= 0; i--) {
    while (k >= t && seg_ornt( /* upper hull */
        result[k-2], result[k-1], ps[i]) <= 0) k--;
    result[k++] = ps[i];
  }

  result.resize(k - 1);
  return result;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int c;
    cin >> c;

    set<ii> edgepts;
    for (int i = 0; i < c; i++) {
        int l;
        cin >> l;

        set<ii> cpts;
        while (l--) {
            int ax, ay;
            cin >> ax >> ay;
            cpts.insert(ii(ax, ay));

            int bx, by;
            cin >> bx >> by;
            cpts.insert(ii(bx, by));
        }

        vector<pt> pts;
        for (auto p : cpts) {
            pts.push_back(pt(p.xx, p.yy));
        }
        vector<pt> hullpts = convex_hull(pts);

        for (auto p : hullpts) {
            edgepts.insert(ii(p.px, p.py));
        }
    }

    cout << edgepts.size() << "\n";
}
